package se.lth.dit.odinmp;
import se.lth.dit.odinmp.*;
import se.lth.dit.odinmp.visitor.*;
import se.lth.dit.odinmp.syntaxtree.*;
import java.lang.*;
import java.util.*;

public class CriticalConstructDescriptor extends ConstructDescriptor {
    public static int nextIndex = 0;
    public static Vector names = new Vector();

    public Statement statement;

    public String name = "odinmp_default";

    public CriticalConstructDescriptor(Statement cs) {
	super(8, "critical", nextIndex++);
	statement = cs;
    }

    public String code(DataBuildingVisitor dbv) {
	StringBuffer retval = new StringBuffer();
	
	retval.append("    ODINMP_TIMING_WAIT_BEGIN;\n");
	retval.append("    pthread_mutex_lock(&odinmp_crit_" + name + ");\n");
	retval.append("    ODINMP_TIMING_WAIT_END;\n");
	dbv.visit(statement);
	retval.append(dbv.rv.toString());
	retval.append("    pthread_mutex_unlock(&odinmp_crit_" + name + ");\n");

	if (!names.contains(name)) {
	    names.addElement(name);
	}

	return new String(retval);
    }
}
