package se.lth.dit.odinmp;
import se.lth.dit.odinmp.*;
import se.lth.dit.odinmp.visitor.*;
import se.lth.dit.odinmp.syntaxtree.*;
import java.lang.*;
import java.util.*;

public class AtomicConstructDescriptor extends ConstructDescriptor {
    public static int nextIndex = 0;

    public ExpressionStatement expressionStatement;

    public AtomicConstructDescriptor(ExpressionStatement es) {
	super(7, "atomic", nextIndex++);
	expressionStatement = es;
    }

    public String code(DataBuildingVisitor dbv) {
	StringBuffer retval = new StringBuffer();
	
	retval.append("    ODINMP_TIMING_WAIT_BEGIN;\n");
	retval.append("    pthread_mutex_lock(&odinmp_atomic_lock);\n");
	retval.append("    ODINMP_TIMING_WAIT_END;\n");
	dbv.visit(expressionStatement);
	retval.append(dbv.rv.toString());
	retval.append("    pthread_mutex_unlock(&odinmp_atomic_lock);\n");
	return new String(retval);
    }
}
