package se.lth.dit.odinmp;
import se.lth.dit.odinmp.*;
import se.lth.dit.odinmp.syntaxtree.*;
import java.util.*;

public class ClauseHandler {
    public void cantHandle(String s) {
	System.err.println(getClass().getName() + ": Cannot handle clause ``" + s + "''");
    }

    public void canHandle(String s) {
	/* OdinMP.debugPrintln(getClass().getName() + ": handling clause ``" + s + "''"); */
    }

    public ClauseHandler() {
    }

    public ClauseHandler(ConstructDescriptor cd) {
    }

    public ClauseHandler(ConstructDescriptor par, ConstructDescriptor wsc) {
    }

    public void handlePrivate(Vector v) {
	cantHandle("private: " + v);
    }

    public void handleFirstprivate(Vector v) {
	cantHandle("firstprivate: " + v);
    }

    public void handleLastprivate(Vector v) {
	cantHandle("lastprivate: " + v);
    }

    public void handleShared(Vector v) {
	cantHandle("shared: " + v);
    }

    public void handleCopyin(Vector v) {
	cantHandle("copyin: " + v);
    }

    public void handleDefault(String s) {
	cantHandle("default: " + s);
    }

    public void handleReduction(String redop, Vector v) {
	cantHandle("reduction: " + redop + " " + v);
    }

    public void handleIf(Expression condition) {
	cantHandle("if: " + condition);
    }

    public void handleNowait() {
	cantHandle("nowait");
    }

    public void handleOrdered() {
	cantHandle("ordered");
    }

    public void handleSchedule(String scheduleKind, Expression chunkSize) {
	cantHandle("schedule: " + scheduleKind + ", " + chunkSize);
    }
}
