package se.lth.dit.odinmp;
import se.lth.dit.odinmp.*;
import se.lth.dit.odinmp.visitor.*;
import se.lth.dit.odinmp.syntaxtree.*;
import java.lang.*;
import java.util.*;

public class ConstructDescriptor {
    public static int nextIndex = 0;

    public int type;
    public String typeString;
    public int index;
    public Hashtable attributesForSymbols = new Hashtable();

    public ConstructDescriptor(int t, String tS, int i) {
	type = t;
	typeString = tS;
	index = i;
	
	/* OdinMP.debugPrintln("New Construct Descriptor: " + this); */	
    }
    
    public ConstructDescriptor() {
	this(0, "undefined", nextIndex++);
    }
    
    public String toString() {
	return typeString + "_" + index;
    }

    public OmpSymbolAttributes attributesForSymbol(Symbol s) {
	if (attributesForSymbols.containsKey(s)) {
	    return (OmpSymbolAttributes)attributesForSymbols.get(s);
	} else {
	    OmpSymbolAttributes osa = new OmpSymbolAttributes(this);
	    attributesForSymbols.put(s, osa);
	    return osa;
	}
    }

    public void cleanAffectedSymbols() {
	attributesForSymbols = new Hashtable();
    }

    public String nli(Spacing spc) {
	return "\n" + spc.spc;
    }

    public String code(DataBuildingVisitor dbv) {
	return "";
    }
}
