package se.lth.dit.odinmp;
import se.lth.dit.odinmp.*;
import se.lth.dit.odinmp.syntaxtree.*;
import java.lang.*;
import java.util.*;

public class Decl {
    public Vector declarationSpecifiers = new Vector();
    public Vector declarationSpecifierTypes = new Vector();
    public Vector symbols = new Vector();
    public Symbol currentSymbol;

    public Decl() {
	/* OdinMP.debugPrintln("Decl " + this + ": constructed."); */
    }

    public void add(String s) {
	/* OdinMP.debugPrintln("Decl " + this + ": adding string ``" + s + "''"); */
	if (currentSymbol != null) {
	    currentSymbol.add(s);
	    /* OdinMP.debugPrintln("      added to currentSymbol"); */
	} else {
	    declarationSpecifiers.addElement(s);
	    /* OdinMP.debugPrintln("      added to declarationSpecifiers"); */
	}
    }

    public Symbol newSymbol() {
	currentSymbol = new Symbol(declarationSpecifiers);
	currentSymbol.dependOnTypes(declarationSpecifierTypes);
	symbols.addElement(currentSymbol);
	/* OdinMP.debugPrintln("Decl " + this + ": adding new symbol"); */
	return currentSymbol;
    }

    public void dependOnType(Symbol type) {
	/* OdinMP.debugPrintln("Decl " + this + ": depending on type ``" + type + "''"); */
	if (currentSymbol != null) {
	    currentSymbol.dependOnType(type);
	    /* OdinMP.debugPrintln("      type depending for currentSymbol"); */
	} else {
	    declarationSpecifierTypes.addElement(type);
	    /* OdinMP.debugPrintln("      type depending for declarationSpecifierTypes"); */
	}
    }
}
