package se.lth.dit.odinmp;
import se.lth.dit.odinmp.*;
import se.lth.dit.odinmp.visitor.*;
import se.lth.dit.odinmp.syntaxtree.*;
import java.lang.*;
import java.util.*;

public class OrderedConstructDescriptor extends ConstructDescriptor {
    public static int nextIndex = 0;
    public Statement statement;
    

    public OrderedConstructDescriptor(Statement cs) {
	super(10, "ordered", nextIndex++);
	statement = cs;
    }

    public String code(DataBuildingVisitor dbv) {
	StringBuffer retval = new StringBuffer();
	retval.append("{\n");
	retval.append("  odinmp_thread_data_t *odinmp_td = odinmp_self_data();\n");
	retval.append("  if (" + OdinMP.THREAD_INFO("odinmp_td") + "->wsc_info != ((void *)0) &&\n");
	retval.append("      " + OdinMP.THREAD_INFO("odinmp_td") + "->wsc_info->type == odinmp_wsc_type_for) {\n");
	retval.append("    \n");
	retval.append("    odinmp_wsc_info_t *wsc_info = (" + OdinMP.THREAD_INFO("odinmp_td") + "->wsc_info);\n");
	retval.append("    odinmp_for_lap_list_t *lap_list = wsc_info->u.wsc_for.lap_list;\n");
	retval.append("    \n");
	retval.append("    " + OdinMP.PRINTF("\"thread %d has in_order = %d\\n\", " + OdinMP.THREAD_INFO("odinmp_td") + "->id, wsc_info->u.wsc_for.slice->in_order") + ";\n");
	retval.append("    ODINMP_TIMING_WAIT_BEGIN\n");
	retval.append("    pthread_mutex_lock(&lap_list->for_data.order_lock);\n");
	retval.append("    ODINMP_TIMING_WAIT_END\n");
	retval.append("    while (lap_list->for_data.in_order != wsc_info->u.wsc_for.slice->in_order) {\n");
	retval.append("      " + OdinMP.PRINTF("\"thread %d has in_order = %d, but current in_order = %d\\n\", " + OdinMP.THREAD_INFO("odinmp_td") + "->id, wsc_info->u.wsc_for.slice->in_order, lap_list->for_data.in_order") + ";\n");
	retval.append("      pthread_cond_wait(&lap_list->for_data.new_order, &lap_list->for_data.order_lock);\n");
	retval.append("    }\n");
	retval.append("    pthread_mutex_unlock(&lap_list->for_data.order_lock);\n");
	retval.append("    " + OdinMP.PRINTF("\"thread %d has in_order = %d, and current in_order = %d - I get to play!\\n\", " + OdinMP.THREAD_INFO("odinmp_td") + "->id, wsc_info->u.wsc_for.slice->in_order, lap_list->for_data.in_order") + ";\n");
	retval.append("  }\n");
	retval.append("}\n");
	retval.append("\n");
	retval.append("  /* original code here */\n");

	dbv.visit(statement);
	retval.append(dbv.rv.toString());
	
	return new String(retval);
    }
}
