package se.lth.dit.odinmp;
import se.lth.dit.odinmp.*;
import java.util.*;

public class SectionsClauseHandler extends SymbolClauseHandler {
    public SectionsConstructDescriptor sectionsConstructDescriptor;

    public SectionsClauseHandler(SymbolFetcher sf, SectionsConstructDescriptor cd) {
	super(sf);
	sectionsConstructDescriptor = cd;
    }

    public void handlePrivate(Vector v) {
	Vector syms = symbolsForNames(v);
	setSharingForSymbolsInConstruct(OmpSymbolAttributes.sharing_Private,
					syms,
					sectionsConstructDescriptor);
	sectionsConstructDescriptor.privateSymbols.addSymbols(syms);
    }

    public void handleFirstprivate(Vector v) {
	Vector syms = symbolsForNames(v);
	setSharingForSymbolsInConstruct(OmpSymbolAttributes.sharing_Firstprivate,
					syms,
					sectionsConstructDescriptor);
	sectionsConstructDescriptor.firstprivateSymbols.addSymbols(syms);
    }

    public void handleLastprivate(Vector v) {
	Vector syms = symbolsForNames(v);
	setSharingForSymbolsInConstruct(OmpSymbolAttributes.sharing_Lastprivate,
					syms,
					sectionsConstructDescriptor);
	sectionsConstructDescriptor.lastprivateSymbols.addSymbols(syms);
    }
    
    /*
      public void handleShared(Vector v) {
      }
    */

    /*
      public void handleCopyin(Vector v) {
      }
    */

    /*
      public void handleDefault(String s) {
      }
    */

    public void handleReduction(String redop, Vector v) {
	Vector vv = symbolsForNames(v);
	Enumeration e = vv.elements();
	while (e.hasMoreElements()) {
	    Symbol s = (Symbol)e.nextElement();
	    OmpSymbolAttributes osa = sectionsConstructDescriptor.attributesForSymbol(s);
	    osa.setSharing(OmpSymbolAttributes.sharing_Reduction);
	    osa.reductionOperator = redop;
	    sectionsConstructDescriptor.reductionSymbols.addSymbol(s);

	    /* OdinMP.debugPrintln("reduction clause: osa = " + osa + ", symbol ``" + s + "'', red_op ``" + osa.reductionOperator + "''"); */
	    
	}
    }
    
    /*
      public void handleIf(String condition) {
      }
    */
    
    public void handleNowait() {
	sectionsConstructDescriptor.nowait = true;
    }
   
    /* 
       public void handleOrdered() {
       }
    */
   
    /* 
       public void handleSchedule(String scheduleKind, String chunksize) {
       }
    */
}
