package se.lth.dit.odinmp;
import se.lth.dit.odinmp.*;
import se.lth.dit.odinmp.syntaxtree.*;
import java.util.*;

public class SingleClauseHandler extends SymbolClauseHandler {
    public SingleConstructDescriptor singleConstructDescriptor;

    public SingleClauseHandler(SymbolFetcher sf, SingleConstructDescriptor cd) {
	super(sf);
	singleConstructDescriptor = cd;
    }

    public void handlePrivate(Vector v) {
	Vector syms = symbolsForNames(v);
	setSharingForSymbolsInConstruct(OmpSymbolAttributes.sharing_Private,
					syms,
					singleConstructDescriptor);
	singleConstructDescriptor.privateSymbols.addSymbols(syms);
    }

    public void handleFirstprivate(Vector v) {
	Vector syms = symbolsForNames(v);
	setSharingForSymbolsInConstruct(OmpSymbolAttributes.sharing_Firstprivate,
					syms,
					singleConstructDescriptor);
	singleConstructDescriptor.firstprivateSymbols.addSymbols(syms);
    }

    /*
      public void handleLastprivate(Vector v) {
      }
    */
    
    /*
      public void handleShared(Vector v) {
      }
    */

    /*
      public void handleCopyin(Vector v) {
      }
    */

    /*
      public void handleDefault(String s) {
      }
    */

    /*
      public void handleReduction(String redop, Vector v) {
      }
    */
    
    /*
      public void handleIf(String condition) {
      }
    */
    
    public void handleNowait() {
	singleConstructDescriptor.nowait = true;
    }
    
    /*
      public void handleSchedule(String scheduleKind, String chunksize) {
      }
    */
}
