package se.lth.dit.odinmp;
import se.lth.dit.odinmp.*;
import java.util.*;

public class SymbolClauseHandler extends ClauseHandler {
    public SymbolFetcher symbolFetcher;
    
    public SymbolClauseHandler(SymbolFetcher sf) {
	super();
	symbolFetcher = sf;
    }

    public Vector symbolsForNames(Vector v) {
	Vector vv = new Vector();
	Enumeration e = v.elements();
	while (e.hasMoreElements()) {
	    String name = (String)e.nextElement();
	    Symbol symbol = symbolFetcher.symbolWithName(name);
	    vv.addElement(symbol);
	}
	return vv;
    }

    public void setSharingForSymbolInConstruct(int sharing, 
					       Symbol symbol, 
					       ConstructDescriptor cd) {
	OmpSymbolAttributes osa = cd.attributesForSymbol(symbol);
	osa.setSharing(sharing);
    }

    public void setSharingForSymbolsInConstruct(int sharing, 
						Vector v,
						ConstructDescriptor cd) {
	Enumeration e = v.elements();
	while (e.hasMoreElements()) {
	    setSharingForSymbolInConstruct(sharing,
					   (Symbol)e.nextElement(),
					   cd);
	}
    }

    public void setSharingForNamesInConstruct(int sharing, 
					      Vector v,
					      ConstructDescriptor cd) {
	setSharingForSymbolsInConstruct(sharing,
					symbolsForNames(v),
					cd);
    }
}
