package se.lth.dit.odinmp;
import java.lang.*;
import java.util.*;

public class SymbolTable {
    public Hashtable symbols;
    public Vector symbolsInOrder;

    public SymbolTable() {
	symbols = new Hashtable();
	symbolsInOrder = new Vector();
    }

    public void addSymbol(Symbol s) {
	/* OdinMP.debugPrintln("" + super.toString() + ": adding symbol ``" + s.name + "'' => " + s); */
	symbols.put(s.name, s);
	symbolsInOrder.addElement(s);
    }

    public void addSymbols(Vector v) {
	Enumeration e = v.elements();
	while (e.hasMoreElements()) {
	    addSymbol((Symbol)e.nextElement());
	}
    }

    public void removeSymbol(Symbol s) {
	/* OdinMP.debugPrintln("" + super.toString() + ": removing symbol ``" + s.name + "'' => " + s); */
	symbols.remove(s.name);
	symbolsInOrder.removeElement(s);
    }

    public boolean containsSymbol(Symbol s) {
	return symbols.contains(s) && symbolsInOrder.contains(s);
    }

    public Symbol symbolWithName(String n) {
	return (Symbol)symbols.get(n);
    }
    
    public String debugToString () {
	String s = super.toString ();
	s = s + " = {\n";
	for (Enumeration e = symbolsInOrder.elements(); 
	     e.hasMoreElements();
	     ) {
	    Symbol o = (Symbol)e.nextElement();
	    s = s + "   " + o.name + " => " + o + "\n";
	}
	s = s + "}\n";
	return s;
    }

    public String realToString () {
	String s = "";
	for (Enumeration e = symbolsInOrder.elements(); 
	     e.hasMoreElements();
	     ) {
	    Symbol o = (Symbol)e.nextElement();
	    s = s + o + ";\n";
	}
	return s;
    }

    public String toString() {
	return realToString();
    }
}
