//
// Generated by JTB 1.1.1
//

package se.lth.dit.odinmp.visitor;
import se.lth.dit.odinmp.syntaxtree.*;
import se.lth.dit.odinmp.*;
import java.util.*;

/**
 * Provides default methods which visit each node in the tree in depth-first
 * order.  Your visitors may extend this class.
 */
public class ReturningVisitor extends DepthFirstVisitor {

    public ReturnValue rv;

    public ReturnValue newReturnValue () {
	return new ReturnValue();
    }
    
    //
    // Auto class visitors--probably don't need to be overridden.
    //
    public void visit(NodeList n) {
	ReturnValue rv = newReturnValue();
	for ( Enumeration e = n.elements(); e.hasMoreElements(); ) {
	    ((Node)e.nextElement()).accept(this); rv.add(this.rv);
	}
    	this.rv = rv;
    }

    public void visit(NodeListOptional n) {
	ReturnValue rv = newReturnValue();
	if ( n.present() )
	    for ( Enumeration e = n.elements(); e.hasMoreElements(); ) {
		((Node)e.nextElement()).accept(this); rv.add(this.rv);
	    }
    	this.rv = rv;
    }
    
    public void visit(NodeOptional n) {
	ReturnValue rv = newReturnValue();
	if ( n.present() ) {
	    n.node.accept(this); rv.add(this.rv);
	}
    	this.rv = rv;
    }
    
    public void visit(NodeSequence n) {
	ReturnValue rv = newReturnValue();
	for ( Enumeration e = n.elements(); e.hasMoreElements(); ) {
	    ((Node)e.nextElement()).accept(this); rv.add(this.rv);
	}
    	this.rv = rv;
    }
    
    public void visit(NodeToken n) {
	ReturnValue rv = newReturnValue(); 
	this.rv = rv;
    }
    
    //
    // User-generated visitor methods below
    //

    /**
     * <PRE>
     * f0 -> ( ExternalDeclaration() | UnknownCpp() )+
     * </PRE>
     */
    public void visit(TranslationUnit n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> ( FunctionDefinition() | Declaration() | ThreadprivateDirective() )
     * </PRE>
     */
    public void visit(ExternalDeclaration n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> [ DeclarationSpecifiers() ]
     * f1 -> Declarator()
     * f2 -> [ DeclarationList() ]
     * f3 -> CompoundStatement()
     * </PRE>
     */
    public void visit(FunctionDefinition n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
	n.f2.accept(this); rv.add(this.rv);
	n.f3.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> DeclarationSpecifiers()
     * f1 -> [ InitDeclaratorList() ]
     * f2 -> &lt;SEMICOLON&gt;
     * </PRE>
     */
    public void visit(Declaration n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
	n.f2.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> ( Declaration() )+
     * </PRE>
     */
    public void visit(DeclarationList n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> ( StorageClassSpecifier() | TypeSpecifier() | TypeQualifier() )+
     * </PRE>
     */
    public void visit(DeclarationSpecifiers n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> &lt;AUTO&gt;
     *       | &lt;REGISTER&gt;
     *       | &lt;STATIC&gt;
     *       | &lt;EXTERN&gt;
     *       | &lt;TYPEDEF&gt;
     * </PRE>
     */
    public void visit(StorageClassSpecifier n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> &lt;VOID&gt;
     *       | &lt;CHAR&gt;
     *       | &lt;SHORT&gt;
     *       | &lt;INT&gt;
     *       | &lt;LONG&gt;
     *       | &lt;FLOAT&gt;
     *       | &lt;DOUBLE&gt;
     *       | &lt;SIGNED&gt;
     *       | &lt;UNSIGNED&gt;
     *       | StructOrUnionSpecifier()
     *       | EnumSpecifier()
     *       | TypedefName()
     * </PRE>
     */
    public void visit(TypeSpecifier n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> &lt;CONST&gt;
     *       | &lt;VOLATILE&gt;
     * </PRE>
     */
    public void visit(TypeQualifier n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>

     * f0 -> StructOrUnion()
     * f1 -> ( [ &lt;IDENTIFIER&gt; ] &lt;LEFTBRACE&gt; StructDeclarationList() &lt;RIGHTBRACE&gt; | &lt;IDENTIFIER&gt; )
     * </PRE>
     */
    public void visit(StructOrUnionSpecifier n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> &lt;STRUCT&gt;
     *       | &lt;UNION&gt;
     * </PRE>
     */
    public void visit(StructOrUnion n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> ( StructDeclaration() )+
     * </PRE>
     */
    public void visit(StructDeclarationList n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> InitDeclarator()
     * f1 -> ( &lt;COMMA&gt; InitDeclarator() )*
     * </PRE>
     */
    public void visit(InitDeclaratorList n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> Declarator()
     * f1 -> [ &lt;OP_ASS&gt; Initializer() ]
     * </PRE>
     */
    public void visit(InitDeclarator n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> SpecifierQualifierList()
     * f1 -> StructDeclaratorList()
     * f2 -> &lt;SEMICOLON&gt;
     * </PRE>
     */
    public void visit(StructDeclaration n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
	n.f2.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> ( TypeSpecifier() | TypeQualifier() )+
     * </PRE>
     */
    public void visit(SpecifierQualifierList n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> StructDeclarator()
     * f1 -> ( &lt;COMMA&gt; StructDeclarator() )*
     * </PRE>
     */
    public void visit(StructDeclaratorList n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> Declarator() [ &lt;COLON&gt; ConstantExpression() ]
     *       | &lt;COLON&gt; ConstantExpression()
     * </PRE>
     */
    public void visit(StructDeclarator n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> &lt;ENUM&gt;
     * f1 -> ( [ &lt;IDENTIFIER&gt; ] &lt;LEFTBRACE&gt; EnumeratorList() &lt;RIGHTBRACE&gt; | &lt;IDENTIFIER&gt; )
     * </PRE>
     */
    public void visit(EnumSpecifier n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> Enumerator()
     * f1 -> ( &lt;COMMA&gt; Enumerator() )*
     * </PRE>
     */
    public void visit(EnumeratorList n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> &lt;IDENTIFIER&gt;
     * f1 -> [ &lt;OP_ASS&gt; ConstantExpression() ]
     * </PRE>
     */
    public void visit(Enumerator n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> [ Pointer() ]
     * f1 -> DirectDeclarator()
     * </PRE>
     */
    public void visit(Declarator n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> ( &lt;IDENTIFIER&gt; | &lt;LEFTPAREN&gt; Declarator() &lt;RIGHTPAREN&gt; )
     * f1 -> ( &lt;LEFTBRACKET&gt; [ ConstantExpression() ] &lt;RIGHTBRACKET&gt; | &lt;LEFTPAREN&gt; ParameterTypeList() &lt;RIGHTPAREN&gt; | &lt;LEFTPAREN&gt; [ IdentifierList() ] &lt;RIGHTPAREN&gt; )*
     * </PRE>
     */
    public void visit(DirectDeclarator n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> &lt;OP_MUL&gt;
     * f1 -> [ TypeQualifierList() ]
     * f2 -> [ Pointer() ]
     * </PRE>
     */
    public void visit(Pointer n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
	n.f2.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> ( TypeQualifier() )+
     * </PRE>
     */
    public void visit(TypeQualifierList n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> ParameterList()
     * f1 -> [ &lt;COMMA&gt; &lt;ELLIPSIS&gt; ]
     * </PRE>
     */
    public void visit(ParameterTypeList n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> ParameterDeclaration()
     * f1 -> ( &lt;COMMA&gt; ParameterDeclaration() )*
     * </PRE>
     */
    public void visit(ParameterList n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> DeclarationSpecifiers()
     * f1 -> ( Declarator() | [ AbstractDeclarator() ] )
     * </PRE>
     */
    public void visit(ParameterDeclaration n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> &lt;IDENTIFIER&gt;
     * f1 -> ( &lt;COMMA&gt; &lt;IDENTIFIER&gt; )*
     * </PRE>
     */
    public void visit(IdentifierList n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> AssignmentExpression()
     *       | &lt;LEFTBRACE&gt; InitializerList() [ &lt;COMMA&gt; ] &lt;RIGHTBRACE&gt;
     * </PRE>
     */
    public void visit(Initializer n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> Initializer()
     * f1 -> ( &lt;COMMA&gt; Initializer() )*
     * </PRE>
     */
    public void visit(InitializerList n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> SpecifierQualifierList()
     * f1 -> [ AbstractDeclarator() ]
     * </PRE>
     */
    public void visit(TypeName n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> ( Pointer() | [ Pointer() ] DirectAbstractDeclarator() )
     * </PRE>
     */
    public void visit(AbstractDeclarator n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> ( &lt;LEFTPAREN&gt; AbstractDeclarator() &lt;RIGHTPAREN&gt; | &lt;LEFTBRACKET&gt; [ ConstantExpression() ] &lt;RIGHTBRACKET&gt; | &lt;LEFTPAREN&gt; [ ParameterTypeList() ] &lt;RIGHTPAREN&gt; )
     * f1 -> ( &lt;LEFTBRACKET&gt; [ ConstantExpression() ] &lt;RIGHTBRACKET&gt; | &lt;LEFTPAREN&gt; [ ParameterTypeList() ] &lt;RIGHTPAREN&gt; )*
     * </PRE>
     */
    public void visit(DirectAbstractDeclarator n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> &lt;IDENTIFIER&gt;
     * </PRE>
     */
    public void visit(TypedefName n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> ( LabeledStatement() | ExpressionStatement() | CompoundStatement() | SelectionStatement() | IterationStatement() | JumpStatement() | OmpConstruct() | UnknownCpp() )
     * </PRE>
     */
    public void visit(Statement n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> &lt;CROSSBAR&gt;
     * f1 -> &lt;UNKNOWN_CPP&gt;
     * </PRE>
     */
    public void visit(UnknownCpp n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> OmpPragma()
     * f1 -> ( ParallelConstruct() | ParallelForConstruct() | ParallelSectionsConstruct() | ForConstruct() | SectionsConstruct() | SingleConstruct() | MasterConstruct() | CriticalConstruct() | AtomicConstruct() | OrderedConstruct() )
     * </PRE>
     */
    public void visit(OmpConstruct n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> OmpPragma()
     * f1 -> ( BarrierDirective() | FlushDirective() )
     * </PRE>
     */
    public void visit(OmpDirective n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> ParallelDirective()
     * f1 -> CompoundStatement()
     * </PRE>
     */
    public void visit(ParallelConstruct n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> &lt;CROSSBAR&gt;
     * f1 -> &lt;PRAGMA&gt;
     * f2 -> &lt;OMP&gt;
     * </PRE>
     */
    public void visit(OmpPragma n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
	n.f2.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> &lt;CROSSBAR&gt;
     * f1 -> &lt;PRAGMA&gt;
     * f2 -> &lt;UNKNOWN_CPP&gt;
     * </PRE>
     */
    public void visit(UnknownPragma n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this);
	n.f1.accept(this);
	n.f2.accept(this);
	((VectorReturnValue)rv).v.addElement("\n");
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> &lt;PARALLEL&gt;
     * f1 -> ( UniqueParallelClause() | DataClause() )*
     * </PRE>
     */
    public void visit(ParallelDirective n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> &lt;IF&gt;
     * f1 -> &lt;LEFTPAREN&gt;
     * f2 -> Expression()
     * f3 -> &lt;RIGHTPAREN&gt;
     * </PRE>
     */
    public void visit(UniqueParallelClause n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
	n.f2.accept(this); rv.add(this.rv);
	n.f3.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

   /**
    * <PRE>
    * f0 -> ForDirective()
    * f1 -> OmpForHeader()
    * f2 -> CompoundStatement()
    * </PRE>
    */
    public void visit(ForConstruct n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
	n.f2.accept(this); rv.add(this.rv);
	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> &lt;FOR&gt;
     * f1 -> ( UniqueForClause() | DataClause() | &lt;NOWAIT&gt; )*
     * </PRE>
     */
    public void visit(ForDirective n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> &lt;ORDERED&gt;
     *       | &lt;SCHEDULE&gt; &lt;LEFTPAREN&gt; ScheduleKind() [ &lt;COMMA&gt; Expression() ] &lt;RIGHTPAREN&gt;
     * </PRE>
     */
    public void visit(UniqueForClause n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> &lt;STATIC&gt;
     *       | &lt;DYNAMIC&gt;
     *       | &lt;GUIDED&gt;
     *       | &lt;RUNTIME&gt;
     * </PRE>
     */
    public void visit(ScheduleKind n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }
    
    /**
     * <PRE>
     * f0 -> &lt;FOR&gt;
     * f1 -> &lt;LEFTPAREN&gt;
     * f2 -> OmpForInitExpression()
     * f3 -> &lt;SEMICOLON&gt;
     * f4 -> OmpForCondition()
     * f5 -> &lt;SEMICOLON&gt;
     * f6 -> OmpForReinitExpression()
     * f7 -> &lt;RIGHTPAREN&gt;
     * </PRE>
     */
    public void visit(OmpForHeader n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
	n.f2.accept(this); rv.add(this.rv);
	n.f3.accept(this); rv.add(this.rv);
	n.f4.accept(this); rv.add(this.rv);
	n.f5.accept(this); rv.add(this.rv);
	n.f6.accept(this); rv.add(this.rv);
	n.f7.accept(this); rv.add(this.rv);
	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> &lt;IDENTIFIER&gt;
     * f1 -> &lt;OP_ASS&gt;
     * f2 -> Expression()
     * </PRE>
     */
    public void visit(OmpForInitExpression n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
	n.f2.accept(this); rv.add(this.rv);
	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> &lt;IDENTIFIER&gt;
     * f1 -> ( &lt;OP_LT&gt; | &lt;OP_LE&gt; | &lt;OP_GT&gt; | &lt;OP_GE&gt; )
     * f2 -> Expression()
     * </PRE>
     */
    public void visit(OmpForCondition n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
	n.f2.accept(this); rv.add(this.rv);
	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> ( &lt;OP_INCR&gt; | &lt;OP_DECR&gt; ) &lt;IDENTIFIER&gt;
     *       | &lt;IDENTIFIER&gt; ( ( &lt;OP_INCR&gt; | &lt;OP_DECR&gt; ) | ( &lt;OP_ADDASS&gt; | &lt;OP_SUBASS&gt; ) Expression() | &lt;IDENTIFIER&gt; ( &lt;OP_ADD&gt; | &lt;OP_SUB&gt; ) Expression() | Expression() &lt;OP_ADD&gt; &lt;IDENTIFIER&gt; )
     * </PRE>
     */
    public void visit(OmpForReinitExpression n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	this.rv = rv;
    }
    
    /**
     * <PRE>
     * f0 -> &lt;SECTIONS&gt;
     * f1 -> ( &lt;NOWAIT&gt; | DataClause() )*
     * f2 -> SectionsScope()
     * </PRE>
     */
    public void visit(SectionsConstruct n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
	n.f2.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> &lt;LEFTBRACE&gt;
     * f1 -> [ CompoundStatement() ]
     * f2 -> ( OmpPragma() &lt;SECTION&gt; CompoundStatement() )+
     * f3 -> &lt;RIGHTBRACE&gt;
     * </PRE>
     */
    public void visit(SectionsScope n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
	n.f2.accept(this); rv.add(this.rv);
	n.f3.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> &lt;SINGLE&gt;
     * f1 -> ( &lt;NOWAIT&gt; | DataClause() )*
     * f2 -> CompoundStatement()
     * </PRE>
     */
    public void visit(SingleConstruct n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
	n.f2.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> &lt;PARALLEL&gt;
     * f1 -> &lt;FOR&gt;
     * f2 -> ( UniqueParallelClause() | UniqueForClause() | DataClause() )+
     * f3 -> IterationStatement()
     * </PRE>
     */
    public void visit(ParallelForConstruct n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
	n.f2.accept(this); rv.add(this.rv);
	n.f3.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> &lt;PARALLEL&gt;
     * f1 -> &lt;SECTIONS&gt;
     * f2 -> ( UniqueParallelClause() | DataClause() )+
     * f3 -> SectionsScope()
     * </PRE>
     */
    public void visit(ParallelSectionsConstruct n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
	n.f2.accept(this); rv.add(this.rv);
	n.f3.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> &lt;MASTER&gt;
     * f1 -> CompoundStatement()
     * </PRE>
     */
    public void visit(MasterConstruct n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> &lt;CRITICAL&gt;
     * f1 -> [ &lt;LEFTPAREN&gt; &lt;IDENTIFIER&gt; &lt;RIGHTPAREN&gt; ]
     * f2 -> CompoundStatement()
     * </PRE>
     */
    public void visit(CriticalConstruct n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
	n.f2.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> &lt;ATOMIC&gt;
     * f1 -> ExpressionStatement()
     * </PRE>
     */
    public void visit(AtomicConstruct n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> &lt;FLUSH&gt;
     * f1 -> [ &lt;LEFTPAREN&gt; VariableList() &lt;RIGHTPAREN&gt; ]
     * </PRE>
     */
    public void visit(FlushDirective n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> &lt;ORDERED&gt;
     * f1 -> CompoundStatement()
     * </PRE>
     */
    public void visit(OrderedConstruct n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> &lt;BARRIER&gt;
     * </PRE>
     */
    public void visit(BarrierDirective n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> OmpPragma()
     * f1 -> &lt;THREADPRIVATE&gt;
     * f2 -> &lt;LEFTPAREN&gt;
     * f3 -> VariableList()
     * f4 -> &lt;RIGHTPAREN&gt;
     * </PRE>
     */
    public void visit(ThreadprivateDirective n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
	n.f2.accept(this); rv.add(this.rv);
	n.f3.accept(this); rv.add(this.rv);
	n.f4.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> &lt;PRIVATE&gt; &lt;LEFTPAREN&gt; VariableList() &lt;RIGHTPAREN&gt;
     *       | &lt;FIRSTPRIVATE&gt; &lt;LEFTPAREN&gt; VariableList() &lt;RIGHTPAREN&gt;
     *       | &lt;LASTPRIVATE&gt; &lt;LEFTPAREN&gt; VariableList() &lt;RIGHTPAREN&gt;
     *       | &lt;SHARED&gt; &lt;LEFTPAREN&gt; VariableList() &lt;RIGHTPAREN&gt;
     *       | &lt;COPYIN&gt; &lt;LEFTPAREN&gt; VariableList() &lt;RIGHTPAREN&gt;
     *       | &lt;DFLT&gt; &lt;LEFTPAREN&gt; ( &lt;SHARED&gt; | &lt;NONE&gt; ) &lt;RIGHTPAREN&gt;
     *       | &lt;REDUCTION&gt; &lt;LEFTPAREN&gt; ReductionOp() &lt;COLON&gt; VariableList() &lt;RIGHTPAREN&gt;
     * </PRE>
     */
    public void visit(DataClause n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> &lt;OP_ADD&gt;
     *       | &lt;OP_MUL&gt;
     *       | &lt;OP_SUB&gt;
     *       | &lt;OP_BITAND&gt;
     *       | &lt;OP_BITXOR&gt;
     *       | &lt;OP_BITOR&gt;
     *       | &lt;OP_OR&gt;
     *       | &lt;OP_AND&gt;
     * </PRE>
     */
    public void visit(ReductionOp n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> &lt;IDENTIFIER&gt;
     * f1 -> ( &lt;COMMA&gt; &lt;IDENTIFIER&gt; )*
     * </PRE>
     */
    public void visit(VariableList n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> ( &lt;IDENTIFIER&gt; &lt;COLON&gt; Statement() | &lt;CASE&gt; ConstantExpression() &lt;COLON&gt; Statement() | &lt;DFLT&gt; &lt;COLON&gt; Statement() )
     * </PRE>
     */
    public void visit(LabeledStatement n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> [ Expression() ]
     * f1 -> &lt;SEMICOLON&gt;
     * </PRE>
     */
    public void visit(ExpressionStatement n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> &lt;LEFTBRACE&gt;
     * f1 -> [ DeclarationList() ]
     * f2 -> [ StatementList() ]
     * f3 -> &lt;RIGHTBRACE&gt;
     * </PRE>
     */
    public void visit(CompoundStatement n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
	n.f2.accept(this); rv.add(this.rv);
	n.f3.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> ( Statement() )+
     * </PRE>
     */
    public void visit(StatementList n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> ( &lt;IF&gt; &lt;LEFTPAREN&gt; Expression() &lt;RIGHTPAREN&gt; Statement() [ &lt;ELSE&gt; Statement() ] | &lt;SWITCH&gt; &lt;LEFTPAREN&gt; Expression() &lt;RIGHTPAREN&gt; Statement() )
     * </PRE>
     */
    public void visit(SelectionStatement n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> ( &lt;WHILE&gt; &lt;LEFTPAREN&gt; Expression() &lt;RIGHTPAREN&gt; Statement() | &lt;DO&gt; Statement() &lt;WHILE&gt; &lt;LEFTPAREN&gt; Expression() &lt;RIGHTPAREN&gt; &lt;SEMICOLON&gt; | &lt;FOR&gt; &lt;LEFTPAREN&gt; [ Expression() ] &lt;SEMICOLON&gt; [ Expression() ] &lt;SEMICOLON&gt; [ Expression() ] &lt;RIGHTPAREN&gt; Statement() )
     * </PRE>
     */
    public void visit(IterationStatement n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> ( &lt;GOTO&gt; &lt;IDENTIFIER&gt; &lt;SEMICOLON&gt; | &lt;CONTINUE&gt; &lt;SEMICOLON&gt; | &lt;BREAK&gt; &lt;SEMICOLON&gt; | &lt;RETURN&gt; [ Expression() ] &lt;SEMICOLON&gt; )
     * </PRE>
     */
    public void visit(JumpStatement n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> AssignmentExpression()
     * f1 -> ( &lt;COMMA&gt; AssignmentExpression() )*
     * </PRE>
     */
    public void visit(Expression n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> UnaryExpression() AssignmentOperator() AssignmentExpression()
     *       | ConditionalExpression()
     * </PRE>
     */
    public void visit(AssignmentExpression n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> ( &lt;OP_ASS&gt; | &lt;OP_MULASS&gt; | &lt;OP_DIVASS&gt; | &lt;OP_MODASS&gt; | &lt;OP_ADDASS&gt; | &lt;OP_SUBASS&gt; | &lt;OP_SLASS&gt; | &lt;OP_SRASS&gt; | &lt;OP_ANDASS&gt; | &lt;OP_XORASS&gt; | &lt;OP_ORASS&gt; )
     * </PRE>
     */
    public void visit(AssignmentOperator n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> LogicalORExpression()
     * f1 -> [ &lt;QUESTION&gt; Expression() &lt;COLON&gt; ConditionalExpression() ]
     * </PRE>
     */
    public void visit(ConditionalExpression n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> ConditionalExpression()
     * </PRE>
     */
    public void visit(ConstantExpression n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> LogicalANDExpression()
     * f1 -> [ &lt;OP_OR&gt; LogicalORExpression() ]
     * </PRE>
     */
    public void visit(LogicalORExpression n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> InclusiveORExpression()
     * f1 -> [ &lt;OP_AND&gt; LogicalANDExpression() ]
     * </PRE>
     */
    public void visit(LogicalANDExpression n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> ExclusiveORExpression()
     * f1 -> [ &lt;OP_BITOR&gt; InclusiveORExpression() ]
     * </PRE>
     */
    public void visit(InclusiveORExpression n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> ANDExpression()
     * f1 -> [ &lt;OP_BITXOR&gt; ExclusiveORExpression() ]
     * </PRE>
     */
    public void visit(ExclusiveORExpression n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> EqualityExpression()
     * f1 -> [ &lt;OP_BITAND&gt; ANDExpression() ]
     * </PRE>
     */
    public void visit(ANDExpression n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> RelationalExpression()
     * f1 -> [ ( &lt;OP_EQ&gt; | &lt;OP_NEQ&gt; ) EqualityExpression() ]
     * </PRE>
     */
    public void visit(EqualityExpression n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> ShiftExpression()
     * f1 -> [ ( &lt;OP_LT&gt; | &lt;OP_GT&gt; | &lt;OP_LE&gt; | &lt;OP_GE&gt; ) RelationalExpression() ]
     * </PRE>
     */
    public void visit(RelationalExpression n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> AdditiveExpression()
     * f1 -> [ ( &lt;OP_SL&gt; | &lt;OP_SR&gt; ) ShiftExpression() ]
     * </PRE>
     */
    public void visit(ShiftExpression n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> MultiplicativeExpression()
     * f1 -> [ ( &lt;OP_ADD&gt; | &lt;OP_SUB&gt; ) AdditiveExpression() ]
     * </PRE>
     */
    public void visit(AdditiveExpression n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> CastExpression()
     * f1 -> [ ( &lt;OP_MUL&gt; | &lt;OP_DIV&gt; | &lt;OP_MOD&gt; ) MultiplicativeExpression() ]
     * </PRE>
     */
    public void visit(MultiplicativeExpression n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> ( &lt;LEFTPAREN&gt; TypeName() &lt;RIGHTPAREN&gt; CastExpression() | UnaryExpression() )
     * </PRE>
     */
    public void visit(CastExpression n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> ( PostfixExpression() | &lt;OP_INCR&gt; UnaryExpression() | &lt;OP_DECR&gt; UnaryExpression() | UnaryOperator() CastExpression() | &lt;SIZEOF&gt; ( UnaryExpression() | &lt;LEFTPAREN&gt; TypeName() &lt;RIGHTPAREN&gt; ) )
     * </PRE>
     */
    public void visit(UnaryExpression n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> ( &lt;OP_BITAND&gt; | &lt;OP_MUL&gt; | &lt;OP_ADD&gt; | &lt;OP_SUB&gt; | &lt;OP_BITNOT&gt; | &lt;OP_NOT&gt; )
     * </PRE>
     */
    public void visit(UnaryOperator n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> PrimaryExpression()
     * f1 -> ( &lt;LEFTBRACKET&gt; Expression() &lt;RIGHTBRACKET&gt; | &lt;LEFTPAREN&gt; [ ArgumentExpressionList() ] &lt;RIGHTPAREN&gt; | &lt;DOT&gt; &lt;IDENTIFIER&gt; | &lt;OP_DEREF&gt; &lt;IDENTIFIER&gt; | &lt;OP_INCR&gt; | &lt;OP_DECR&gt; )*
     * </PRE>
     */
    public void visit(PostfixExpression n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> ( &lt;IDENTIFIER&gt; | Constant() | &lt;LEFTPAREN&gt; Expression() &lt;RIGHTPAREN&gt; )
     * </PRE>
     */
    public void visit(PrimaryExpression n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> AssignmentExpression()
     * f1 -> ( &lt;COMMA&gt; AssignmentExpression() )*
     * </PRE>
     */
    public void visit(ArgumentExpressionList n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
	n.f1.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

    /**
     * <PRE>
     * f0 -> &lt;INTEGER_LITERAL&gt;
     *       | &lt;FLOATING_POINT_LITERAL&gt;
     *       | &lt;CHARACTER_LITERAL&gt;
     *       | &lt;STRING_LITERAL&gt;
     * </PRE>
     */
    public void visit(Constant n) {
	ReturnValue rv = newReturnValue();
	n.f0.accept(this); rv.add(this.rv);
    	this.rv = rv;
    }

}
